import { isValidElement } from "react";
export const splitElement = (element) => element.split("");
export function JSXToText(element) {
    if (isValidElement(element)) {
        const { children } = element.props;
        if (Array.isArray(children))
            return children.map((child) => JSXToText(child)).join(" ") + " ";
        return JSXToText(children);
    }
    return typeof element === "string" ? element : typeof element === "number" ? element.toString() : "";
}
export function JSXToArray(element) {
    if (isValidElement(element)) {
        const { children } = element.props;
        if (Array.isArray(children))
            return children.map((child) => JSXToArray(child));
        return JSXToArray(children);
    }
    return typeof element === "string" ? splitElement(element) : typeof element === "number" ? [element.toString()] : [];
}
export function findWordIndex(words, index) {
    let currentIndex = 0;
    function recursiveSearch(array, parentIndex) {
        if (array.length)
            for (let i = 0; i < array.length; i++) {
                const element = array[i];
                if (Array.isArray(element)) {
                    const result = recursiveSearch(element, i);
                    if (result !== null)
                        return `${parentIndex === undefined ? "" : parentIndex + "-"}${result}`;
                }
                else {
                    currentIndex += element.length;
                    if (currentIndex > index)
                        return `${parentIndex === undefined ? "" : parentIndex + "-"}${i}`;
                }
            }
        currentIndex++;
        return null;
    }
    return recursiveSearch(words);
}
